//+------------------------------------------------------------------+
//|                                                   i-Sessions.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|  16.11.2005                               |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

#property indicator_chart_window

//-------    -------------------------------
extern int    NumberOfDays = 50;        //  
extern string WellingtonBegin     = "14:00";   //  
extern string WellingtonEnd       = "23:00";   //  
extern color  WellingtonColor     = PaleGreen; //  
extern string SydneyBegin     = "14:00";   //  
extern string SydneyEnd       = "23:00";   //  
extern color  SydneyColor     = PaleGreen; //  
extern string TokyoBegin     = "14:00";   //  
extern string TokyoEnd       = "23:00";   //  
extern color  TokyoColor     = PaleGreen; //  
extern string DubaiBegin     = "14:00";   //  
extern string DubaiEnd       = "23:00";   //  
extern color  DubaiColor     = PaleGreen; //  
extern string SingaporBegin     = "07:00";   //  
extern string SingaporEnd       = "16:00";   //  
extern color  SingaporColor     = Tan;       //  
extern string ShanghaiBegin     = "14:00";   //  
extern string ShanghaiEnd       = "23:00";   //  
extern color  ShanghaiColor     = PaleGreen; //  
extern string LondonBegin     = "14:00";   //  
extern string LondonEnd       = "23:00";   //  
extern color  LondonColor     = PaleGreen; //  
extern string USABegin     = "14:00";   //   
extern string USAEnd       = "23:00";   //   
extern color  USAColor     = PaleGreen; //   

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  DeleteObjects();
  for (int i=0; i<NumberOfDays; i++) {
    CreateObjects("To"+i, TokyoColor);
    CreateObjects("Si"+i, SingaporColor);
    CreateObjects("Sh"+i, ShanghaiColor);
    CreateObjects("We"+i, WellingtonColor);
    CreateObjects("Sy"+i, SydneyColor);
    CreateObjects("Du"+i, DubaiColor);
    CreateObjects("Lo"+i, LondonColor);
    CreateObjects("Us"+i, USAColor);
  }
  Comment("");
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
  DeleteObjects();
  Comment("");
}

//+------------------------------------------------------------------+
//|                                        |
//| :                                                       |
//|   no -                                        |
//|   cl -                                                |
//+------------------------------------------------------------------+
void CreateObjects(string no, color cl) {
  ObjectCreate(no, OBJ_RECTANGLE, 0, 0,0, 0,0);
  ObjectSet(no, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(no, OBJPROP_COLOR, cl);
  ObjectSet(no, OBJPROP_BACK, True);
}

//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void DeleteObjects() {
  for (int i=0; i<NumberOfDays; i++) {
    ObjectDelete("To"+i);
    ObjectDelete("Si"+i);
    ObjectDelete("Sh"+i);
    ObjectDelete("We"+i);
    ObjectDelete("Sy"+i);
    ObjectDelete("Du"+i);
    ObjectDelete("Lo"+i);
    ObjectDelete("Us"+i);
  }
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {
  datetime dt=CurTime();

  for (int i=0; i<NumberOfDays; i++) {
    DrawObjects(dt, "To"+i, TokyoBegin, TokyoEnd);
    DrawObjects(dt, "Si"+i, SingaporBegin, SingaporEnd);
    DrawObjects(dt, "Sh"+i, ShanghaiBegin, ShanghaiEnd);
    DrawObjects(dt, "Lo"+i, LondonBegin, LondonEnd);
    DrawObjects(dt, "Us"+i, USABegin, USAEnd);
    DrawObjects(dt, "We"+i, WellingtonBegin, WellingtonEnd);
    DrawObjects(dt, "Sy"+i, SydneyBegin, SydneyEnd);
    DrawObjects(dt, "Du"+i, DubaiBegin, DubaiEnd);
    dt=decDateTradeDay(dt);
    while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
  }
}

//+------------------------------------------------------------------+
//|                                       |
//| :                                                       |
//|   dt -                                           |
//|   no -                                        |
//|   tb -                                          |
//|   te -                                       |
//+------------------------------------------------------------------+
void DrawObjects(datetime dt, string no, string tb, string te) {
  datetime t1, t2;
  double   p1, p2;
  int      b1, b2;

  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
  ObjectSet(no, OBJPROP_TIME1 , t1);
  ObjectSet(no, OBJPROP_PRICE1, p1);
  ObjectSet(no, OBJPROP_TIME2 , t2);
  ObjectSet(no, OBJPROP_PRICE2, p2);
}

//+------------------------------------------------------------------+
//|                                  |
//| :                                                       |
//|   dt -                                           |
//+------------------------------------------------------------------+
datetime decDateTradeDay (datetime dt) {
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0) {
    tm--;
    if (tm==0) {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+

